#!/usr/bin/perl -w


#====================================================================
# What's this ?
#====================================================================
# Script designed for cacti [ http://www.cacti.net ]
#
# Tested with perl v5.8.5 built for i386-linux-thread-multi 
# Cacti Version	0.8.6j
# Get Get vars that returns 0:ON or 1:OFF
# fan: fan is ON, actually neens that unit works
# comp:  compressor is ON
# R1: Resistance N 1 is ON 
# R2:0 Resistance N 2 is ON
# desum: desumidificator is ON
# hum: humidificator is ON
# major: major alarm on the unit
# minor: minor alarm on the unit
# pCOweb integrated in lexnox Unit
# General information: 	pcoweb@carel.com
# Used Mib decription : CAREL-ahu_pco_v18.MIB
# 
# 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#====================================================================


# --------------------------------------------------
# ARGV[0] = <hostname> required
# ARGV[1] = <snmp version> required
# ARGV[2] = <snmp community> required
# ARGV[3] = <snmp port> required
# ARGV[4] = <snmp timeout> required
# --------------------------------------------------

$in_hostname 	= $ARGV[0] if defined $ARGV[0];
$in_version 	= $ARGV[1] if defined $ARGV[1];
$in_community 	= $ARGV[2] if defined $ARGV[2];
$in_port 	= $ARGV[3] if defined $ARGV[3];
$in_timeout 	= $ARGV[4] if defined $ARGV[4];


# usage notes
if (
	( ! defined $in_hostname ) ||
	( ! defined $in_version ) ||
	( ! defined $in_community ) ||
	( ! defined $in_port ) ||
	( ! defined $in_timeout )
	) {
	print 	"Get status (on/off) for fan comp Resistance1 Resistance2 desum hum \nmajor_alarm minor_alarm using snmp vars on pCOweb integrated in lexnox Unit\n
                usage:\n
		$0 <host> <snmp version> < snmp community> <snmp port> <snmp timeout>\n
                Output fan:1/0 comp:1/0 R1:1/0 R2:1/0 desum:1/0 hum:1/0 major:1/0 minor:1/0\n\n";
	exit;
}

# here are some interresting variables returning 0=off 1=on
my $_cmd_fan_on= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.15.0";
my $_cmd_comp_on= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.16.0";
my $_cmd_resistance1_on= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.18.0";
my $_cmd_resistance2_on= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.19.0";
my $_cmd_desumidification_on= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.20.0";
my $_cmd_humidification_on= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.25.0";
my $_cmd_major_alarm= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.22.0";
my $_cmd_minor_alarm= "snmpget -OvqU -v $in_version  -c $in_community -t $in_timeout $in_hostname:$in_port 1.3.6.1.4.1.9839.2.1.1.27.0";


my $_fan_on =`$_cmd_fan_on`;
my $_comp_on=`$_cmd_comp_on`;
my $_resistance1_on=`$_cmd_resistance1_on`;
my $_resistance2_on=`$_cmd_resistance2_on`;
my $_desumidification_on=`$_cmd_desumidification_on`; 
my $_humidification_on=`$_cmd_humidification_on`;
my $_major_alarm=`$_cmd_major_alarm`;
my $_minor_alarm= `$_cmd_minor_alarm`;

chomp($_fan_on);
chomp($_comp_on);
chomp($_resistance1_on);
chomp($_resistance2_on);
chomp($_desumidification_on);
chomp($_humidification_on);
chomp($_major_alarm);
chomp($_minor_alarm);



# if you want to translate here, be sure to modify "GET Clim_lenox " cacti date input methode (simple ;)
print "fan:$_fan_on comp:$_comp_on R1:$_resistance1_on R2:$_resistance2_on desum:$_desumidification_on hum:$_humidification_on major:$_major_alarm minor:$_minor_alarm\n";
